JUCE: MPEMessages Class Reference

JUCE

Static Public Member Functions | Static Public Attributes | List of all members
MPEMessages Class Reference
juce_audio_basics » mpe

This helper class contains the necessary helper functions to generate MIDI messages that are exclusive to MPE, such as defining the upper and lower MPE zones and setting per-note and master pitchbend ranges. More...

`#include <juce_MPEMessages.h>`

## Static Public Member Functions
static MidiBuffer | setLowerZone (int numMemberChannels=0, int perNotePitchbendRange=48, int masterPitchbendRange=2)
| Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will set the lower MPE zone. More...
static MidiBuffer | setUpperZone (int numMemberChannels=0, int perNotePitchbendRange=48, int masterPitchbendRange=2)
| Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will set the upper MPE zone. More...
static MidiBuffer | setLowerZonePerNotePitchbendRange (int perNotePitchbendRange=48)
| Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will set the per-note pitchbend range of the lower MPE zone. More...
static MidiBuffer | setUpperZonePerNotePitchbendRange (int perNotePitchbendRange=48)
| Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will set the per-note pitchbend range of the upper MPE zone. More...
static MidiBuffer | setLowerZoneMasterPitchbendRange (int masterPitchbendRange=2)
| Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will set the master pitchbend range of the lower MPE zone. More...
static MidiBuffer | setUpperZoneMasterPitchbendRange (int masterPitchbendRange=2)
| Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will set the master pitchbend range of the upper MPE zone. More...
static MidiBuffer | clearLowerZone ()
| Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will clear the lower zone. More...
static MidiBuffer | clearUpperZone ()
| Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will clear the upper zone. More...
static MidiBuffer | clearAllZones ()
| Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will clear the lower and upper zones. More...
static MidiBuffer | setZoneLayout (MPEZoneLayout layout)
| Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will reset the whole MPE zone layout of the device to the layout passed in. More...

## Static Public Attributes
static const int | zoneLayoutMessagesRpnNumber = 6
| The RPN number used for MPE zone layout messages. More...

## Detailed Description

This helper class contains the necessary helper functions to generate MIDI messages that are exclusive to MPE, such as defining the upper and lower MPE zones and setting per-note and master pitchbend ranges.

You can then send them to your MPE device using MidiOutput::sendBlockOfMessagesNow.

All other MPE messages like per-note pitchbend, pressure, and third dimension, are ordinary MIDI messages that should be created using the MidiMessage class instead. You just need to take care to send them to the appropriate per-note MIDI channel.

Note: If you are working with an MPEZoneLayout object inside your app, you should not use the message sequences provided here. Instead, you should change the zone layout programmatically with the member functions provided in the MPEZoneLayout class itself. You should also make sure that the Expressive MIDI zone layout of your C++ code and of the MPE device are kept in sync.

See also
  MidiMessage, MPEZoneLayout

## Member Function Documentation

## ◆ setLowerZone()

static MidiBuffer MPEMessages::setLowerZone | ( | int | numMemberChannels = `0`,
|  | int | perNotePitchbendRange = `48`,
|  | int | masterPitchbendRange = `2`
| ) |  |
| static

Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will set the lower MPE zone.

## ◆ setUpperZone()

static MidiBuffer MPEMessages::setUpperZone | ( | int | numMemberChannels = `0`,
|  | int | perNotePitchbendRange = `48`,
|  | int | masterPitchbendRange = `2`
| ) |  |
| static

Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will set the upper MPE zone.

## ◆ setLowerZonePerNotePitchbendRange()

static MidiBuffer MPEMessages::setLowerZonePerNotePitchbendRange | ( | int | perNotePitchbendRange = `48` | ) |
| static

Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will set the per-note pitchbend range of the lower MPE zone.

## ◆ setUpperZonePerNotePitchbendRange()

static MidiBuffer MPEMessages::setUpperZonePerNotePitchbendRange | ( | int | perNotePitchbendRange = `48` | ) |
| static

Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will set the per-note pitchbend range of the upper MPE zone.

## ◆ setLowerZoneMasterPitchbendRange()

static MidiBuffer MPEMessages::setLowerZoneMasterPitchbendRange | ( | int | masterPitchbendRange = `2` | ) |
| static

Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will set the master pitchbend range of the lower MPE zone.

## ◆ setUpperZoneMasterPitchbendRange()

static MidiBuffer MPEMessages::setUpperZoneMasterPitchbendRange | ( | int | masterPitchbendRange = `2` | ) |
| static

Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will set the master pitchbend range of the upper MPE zone.

## ◆ clearLowerZone()

static MidiBuffer MPEMessages::clearLowerZone | ( |  | ) |
| static

Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will clear the lower zone.

## ◆ clearUpperZone()

static MidiBuffer MPEMessages::clearUpperZone | ( |  | ) |
| static

Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will clear the upper zone.

## ◆ clearAllZones()

static MidiBuffer MPEMessages::clearAllZones | ( |  | ) |
| static

Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will clear the lower and upper zones.

## ◆ setZoneLayout()

static MidiBuffer MPEMessages::setZoneLayout | ( | MPEZoneLayout | layout | ) |
| static

Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will reset the whole MPE zone layout of the device to the layout passed in.

This will first clear the current lower and upper zones, then then set the zones contained in the passed-in zone layout, and set their per-note and master pitchbend ranges to their current values.

## Member Data Documentation

## ◆ zoneLayoutMessagesRpnNumber

const int MPEMessages::zoneLayoutMessagesRpnNumber = 6
| static

The RPN number used for MPE zone layout messages.

Pitchbend range messages (both per-note and master) are instead sent on RPN 0 as in standard MIDI 1.0.

The documentation for this class was generated from the following file:

- juce_MPEMessages.h